package dev.peerat.backend.routes.admins.chapter;

import java.util.regex.Matcher;

import dev.peerat.backend.model.Chapter;
import dev.peerat.backend.repository.DatabaseRepository;
import dev.peerat.framework.Context;
import dev.peerat.framework.HttpReader;
import dev.peerat.framework.HttpWriter;
import dev.peerat.framework.Response;
import dev.peerat.framework.Route;
import dev.peerat.framework.utils.json.JsonMap;

public class GetChapter implements Response{
	
	private DatabaseRepository repo;
	
	public GetChapter(DatabaseRepository repo){
		this.repo = repo;
	}
	
	@Route(path = "^/admin/chapter/(\\d+)$", needLogin = true)
	public void exec(Matcher matcher, Context context, HttpReader reader, HttpWriter writer) throws Exception{
		Chapter chapter = this.repo.getAdminChapter(Integer.parseInt(matcher.group(1)));
		JsonMap json = new JsonMap();
		json.set("name", chapter.getName());
		json.set("start", chapter.getStartDate());
		json.set("end", chapter.getEndDate());
		
		context.response(200);
		writer.write(json.toString()+"\n");
	}

}
